// //插件弹出框按钮定义
// var buttons = [
// 	{title: "人工翻译",iconUrl: safari.extension.baseURI+"/images/translate.png"},
// 	{title: "插件设置",iconUrl: safari.extension.baseURI+"/images/config.png"}
// ];
//资讯弹框任务id
var notification_timedtask_id;

//定时任务
timedTask();

// //清理临时缓存
// function clear(notificationId){
// 	localStorage.removeItem("cache_info_"+notificationId);
// }

// //弹框非按钮监听器
// chrome.notifications.onClicked.addListener(function(notificationId){
// 	open_info_url(localStorage["cache_info_"+notificationId]);
// });


// //弹框关闭监听器
// chrome.notifications.onClosed.addListener(function(notificationId){
// 	open_info_url(localStorage["cache_info_"+notificationId])
// 	localStorage.removeItem("cache_info_"+notificationId);
// 	clear(notificationId);
// });

// //打开弹出框中网页超链
// function open_info_url(url){
// 	chrome.tabs.create({url:url});
// }



//桌面通知异步请求(右下角弹框)
function notification_box_show_ajax(){
	//请求服务器最新资讯
	//请求参数：最后一条服务器下发的消息(可以为空,意为该插件从未接收过服务器的消息推送),浏览器信息,用户自定义配置信息
	//最后一条服务器下发的消息  key:id  value:localStorage['cache_last_info_id']  
	//浏览器信息  key:info_browsers value:localStorage['log_common_info_browser']
	//用户自定义弹框配置信息  key:info_user_state  vaule:localStorage['config_new_info']
	//如果请求到了最新资讯,则开始弹框,否则不弹框
	//....
	
	var data = [];
	$.ajax({
	  url: info_url,
	  type: 'POST',
	  xhrFields: {
      'Access-Control-Allow-Origin': '*'
   	  }, 
   	   headers: {
            "access_token":getResult()
      },
   	  async:false,
	  data: {
	  	id: localStorage['cache_last_info_id']=== undefined ? "" : localStorage['cache_last_info_id'],
	  	info_browsers: localStorage['log_common_info_browser'],
	  	info_user_state: localStorage['config_auto_show_tips'].split("_")[0]
	  },
	  dataType:"json",
	  success: function(d) {
	    //called when successful
	    	data = d.data;
	  }
	});
	//发请求到content进行ajax异步请求获取最新资讯
	var param = {
	  	configurl: safari.extension.baseURI+"config.html",
	  	data:data
	};

	if(data.length != 0){
		console.log(param)
		safari.application.activeBrowserWindow.activeTab.page.dispatchMessage(
			// action_change_plugin_bar
			"notification_action", 
			{
				param:param
			}
		);
	}

}




/**
 * 资讯弹框定时任务
 */
function notification_timedtask(){
	notification_box_execute();
	var tasksec = 60*15;//15分钟请求一次,获取最新资讯
	notification_timedtask_id = setInterval(function() {
		notification_box_execute();
	}, 1000 * tasksec);
}


/**
 * 执行弹框任务-流程控制-配置控制
 */
function notification_box_execute(){
	var config_new_info = localStorage['config_new_info'].split("_");

	if(config_new_info != null){

		if(config_new_info[0] == 1){//用户设置允许,弹!

			//弹框动作
			notification_box_show_ajax();

		}else{//一周不弹,检测一周过了没
			//               周  天   时   分   秒
			var weeklength = 7 * 24 * 60 * 60 * 1000;//得到一周的毫秒长度
			var currentTime = new Date().getTime();//当前时间

			if((currentTime - config_new_info[1]) > weeklength){//超过了一周,弹!
				//弹框动作
				notification_box_show_ajax();
				//弹框OK后顺便把配置项挪到默认选项
				localStorage["config_new_info"] = "1_1";//将用户配置项设置为默认值,随时弹框

			}else{//未超过一周,暂停弹框
				//销毁弹框任务对象
				//window.clearInterval(notification_timedtask_id);
			}

		}
	}else{
		//弹框动作
		notification_box_show_ajax();
	}
}


/**
 * 定时任务
 */
function timedTask(){
	//资讯弹框定时任务
	notification_timedtask();
}